-------------------------------------------------------------------------------------------------------------------------------
	-------------------------------------------------  Globals  -------------------------------------------------
-------------------------------------------------------------------------------------------------------------------------------

local BREWARD, Core 					= 			...
BraveReward 							= 			LibStub("AceAddon-3.0"):NewAddon(BREWARD, "AceConsole-3.0", "AceEvent-3.0")
local ACR 								= 			LibStub("AceConfigRegistry-3.0")
local AceConfigDialog 					= 			LibStub("AceConfigDialog-3.0")
local rollUnits							=			{}

-------------------------------------------------------------------------------------------------------------------------------
	-------------------------------------------------  Frames  -------------------------------------------------
-------------------------------------------------------------------------------------------------------------------------------

local f 								= 			CreateFrame("Frame")
local hbtext 							=			CreateFrame("Frame", "hbtext", UIParent)
local HealthBarText 					= 			hbtext:CreateFontString("HealthBarText", "OVERLAY", UIParent)
-------------------------------------------------------------------------------------------------------------------------------
		--------------------------------------------  Enchants and Flasks  --------------------------------------------
-------------------------------------------------------------------------------------------------------------------------------

local enchants = {

	--------- RINGS ---------

	-- Wort des kritischen Treffers +150
	[5423] = 150,
	-- Wort des Tempos +150
	[5424] = 150,
	-- Wort der Meisterschaft +150
	[5425] = 150,
	-- Wort der Vielseitigkeit +150
	[5426] = 150,
	
	
	-- Bindung des kritischen Treffers +200
	[5427] = 200,
	-- Bindung der Tempos +200
	[5428] = 200,
	-- Bindung der Meisterschaft +200
	[5429] = 200,
	-- Bindung der Vielseitigkeit +200
	[5430] = 200,
	
	--------- CLOAKS ---------
	
	-- Wort der Stärke +150
	[5431] = 150,
	-- Wort der Beweglichkeit +150
	[5432] = 150,
	-- Wort der Intelligenz +150
	[5433] = 150,
	
	
	-- Bindung der Stärke +200
	[5434] = 200,
	-- Bindung der Beweglichkeit +200
	[5435] = 200,
	-- Bindung der Intelligenz +200
	[5436] = 200,
	
	--------- NECK ---------
	
	-- Mal der Klaue
	[5437] = 200,
	-- Mal der fernen Armee
	[5438] = 200,
	-- Mal des verborgenen Satyrs
	[5439] = 200,
	-- Mal des schweren Balgs
	[5889] = 200,
	-- Mal des erfahrenen Soldaten
	[5890] = 200,
	-- Mal der uralten Priesterin
	[5891] = 200,
}

local flasks = {
	
	-- Int Flask
	[188031] = 1300,
	-- Agi Flask
	[188033] = 1300,
	-- Str Flask
	[188034] = 1300,
	-- Stamina Flask
	[188035] = 1950
	
}

local food = {

	[201330]=225,
	[201332]=225,
	[201223]=225,
	[201334]=225,
	[201336]=225,
	[225598]=300,
	[225599]=300,
	[225597]=300,
	[225600]=300,
	[225601]=300,
	[225603]=375,
	[225604]=375,
	[225602]=375,
	[225605]=375,
	[225606]=375,
}

-------------------------------------------------------------------------------------------------------------------------------
		-------------------------------------------------  Preferences  -------------------------------------------------
-------------------------------------------------------------------------------------------------------------------------------

local addonName 						= 			"Brave Reward"
local bracketColor						=			"|cffFF4500"
local colorReset 						= 			"|r"
local bracketO 							= 			bracketColor .. "<" .. colorReset
local bracketC 							= 			bracketColor .. ">" .. colorReset
local prefixColor 						= 			"|cffffcc00"
local messageColor 						= 			"|cff00ccff"
local difficultyColor					=			"|cffFF4500"  --DIFFICULTY COLOR
local prefix 							= 			bracketO .. prefixColor .. addonName .. colorReset .. bracketC
local bigIntPrefix 						= 			"."
local BRLoaded 							= 			addonName .. " was loaded successfully."
local options 							=			{}

local rolls								=			{}
local unitData 							= 			{}
local inspectionInProgress				=			false
local unitQuery							=			{}

local slotsToCheck						=			{"NeckSlot", "BackSlot", "Finger0Slot", "Finger1Slot"}
local bonusToSlot						=			{5, 3, 3, 3}
local bonusToAura						=			{["Flask"] = 10, ["Buffood"] = 5}
local bonus								=			0
local FlaskName_eng						=			"Flask"
local FlaskName_ger						=			"Fläschchen"


local msgData, length, result_raw, result, result_sec, result_thrd, result_min, result_max

-------------------------------------------------------------------------------------------------------------------------------
	-------------------------------------------------  Events  -------------------------------------------------
-------------------------------------------------------------------------------------------------------------------------------

local function RegisterEvents(self, ...)
	for i=1,select('#', ...) do
		self:RegisterEvent(select(i, ...))
	end
end

f.RegisterEvents = RegisterEvents
f:RegisterEvents("PLAYER_REGEN_ENABLED", "CHAT_MSG_SYSTEM", "PLAYER_REGEN_DISABLED", "PLAYER_TARGET_CHANGED", "ADDON_LOADED", "PLAYER_ENTERING_WORLD", "ZONE_CHANGED", "ZONE_CHANGED_INDOORS", "UNIT_INVENTORY_CHANGED", "INSPECT_READY")

-------------------------------------------------------------------------------------------------------------------------------
	-------------------------------------------------  CORE - BEGIN  -------------------------------------------------
-------------------------------------------------------------------------------------------------------------------------------

function BraveReward:formatIntToComma(str)

    str = tostring(str)   -- now you can feed it numbers instead of strings
    local prefix, number, suffix = str:match"(%D*%d)(%d+)(%D*)"
	if number ~= nil then
		return prefix .. number:reverse():gsub("(%d%d%d)","%1" .. bigIntPrefix):reverse() .. suffix
	end
end

-------------------------------------------------------------------------------------------------------------------------------
	-------------------------------------------------  INTERNAL MESSAGE  -------------------------------------------------
-------------------------------------------------------------------------------------------------------------------------------


function BraveReward:newMsg(msg)
	print(prefix .. messageColor .. " " .. msg .. colorReset)
end


-------------------------------------------------------------------------------------------------------------------------------
	-------------------------------------------------  PROFILE CONFIG  -------------------------------------------------
-------------------------------------------------------------------------------------------------------------------------------

local defaults = {
    profile = {
		enableAnimations				=			false,
    },
}

-------------------------------------------------------------------------------------------------------------------------------
	-------------------------------------------------  ON INITIALIZE  -------------------------------------------------
-------------------------------------------------------------------------------------------------------------------------------

function BraveReward:OnInitialize()

	--[[local screenRes						=			({GetScreenResolutions()})[GetCurrentResolution()]
	local resVals 							=			BraveReward:split(screenRes, "x")
	local screenResX						=			resVals[1]
	local screenResY						=			resVals[2]
	screenResX_start						=			(screenResX / 2) * -1
	screenResX_end							=			screenResX / 2
	screenResY_start						=			(screenResY / 2) * -1
	screenResY_end							=			screenResY / 2]]--

	-- Called when the addon is loaded
    self.db = LibStub("AceDB-3.0"):New("BraveRewardDB", defaults, true)

		--[[ACR:RegisterOptionsTable(BREWARD, options)
			local optionFrame = AceConfigDialog:AddToBlizOptions(BREWARD, BREWARD)

			self:RegisterChatCommand("ah", function() 
			
				InterfaceOptionsFrame_OpenToCategory(optionFrame) 
			
			end, false)
			self:RegisterChatCommand("BraveReward", function()
			
				InterfaceOptionsFrame_OpenToCategory(optionFrame)
				
			end)
			self:RegisterChatCommand("BRLoaded", function()
			
				BraveReward:showLoadedBosses()
				
			end)]]--
			
			
		BraveReward:newMsg(BRLoaded);
end



----------------------------------------
-- End of Options Table
----------------------------------------

function BraveReward:split(source, delimiters)
        local elements = {}
        local pattern = '([^'..delimiters..']+)'
        string.gsub(source, pattern, function(value) elements[#elements + 1] =     value;  end);
        return elements
  end

  
function BraveReward:round(int)
  return int>=0 and math.floor(int+0.5) or math.ceil(int-0.5)
end

function BraveReward:tablelength(T)
  local count = 0
  for _ in pairs(T) do count = count + 1 end
  return count
end

function BraveReward:inTable(tbl, item)
    for key, value in pairs(tbl) do
	
        if tonumber(key) == item then 
			return true
		end
		
    end
    return false
end

function BraveReward:StringContains(str, value)
	return string.match(' '..str..' ', '%W'..value..'%W') ~= nil
end

function BraveReward:LoadInventory(unit)

		NotifyInspect(unit)

end

function BraveReward:LoadEnchants(itemLink)
	
		local _, _, Color, Ltype, Id, Enchant, Gem1, Gem2, Gem3, Gem4,
		Suffix, Unique, LinkLvl, Name = string.find(itemLink,
		"|?c?f?f?(%x*)|?H?([^:]*):?(%d+):?(%d*):?(%d*):?(%d*):?(%d*):?(%d*):?(%-?%d*):?(%-?%d*):?(%d*):?(%d*):?(%-?%d*)|?h?%[?([^%[%]]*)%]?|?h?|?r?")
		
	if(Enchant ~= "") then
		return BraveReward:inTable(enchants, tonumber(Enchant))
	else
		return false
	end
end

function BraveReward:GetUnitAura(unit, tbl)
	
	local auras = {}
	local auraID = 0
	local i = 1
	
	repeat
		n,_,_,_,_,_,_,_,_,_,auraID = UnitAura(unit, i)
		if auraID == nil then break end
		
		if (BraveReward:inTable(tbl, auraID)) and auraID ~= nil then
			return auraID
		end
		
		-- print(n .. ": " .. auraID)
		
		i = i + 1
	until auraID == nil
	
	return false
end

-------------------------------------------------------------------------------------------------------------------------------
	-------------------------------------------------  CORE FUNCTION  -------------------------------------------------
-------------------------------------------------------------------------------------------------------------------------------

function BraveReward:GetUnit(name)
	
	local unitID = "player"

	if IsInRaid() then
		for i=1, 40 do
			local raidname = GetRaidRosterInfo(i)
			
			if(name == raidname) then
				
				unitID = "raid" .. i
			end
			
			if(name == nil) then
				break
			end
			
		end
	end
	for i=1, 4 do
	
	
		if UnitName("party" .. i) ~= nil and UnitName("party" .. i) == name then
			unitID = "party" .. i
		end
	end
	
	return unitID
end

function BraveReward:ProcessInventory(unit, player, rollNum)
	
	unitData[rollUnits[player]]["inspectReady"] = false
	unitData[rollUnits[player]]["inventoryReady"] = false
	local requestSent = false
	local inventoryTicker, inventoryForceTicker
	
	inventoryTicker = C_Timer.NewTicker(1,
	function()
	
		if requestSent == false then
		
			NotifyInspect(unit)
			requestSent = true
		
		end
		
		-- print("Tick")
	
		if unitData[unit]["inspectReady"] == true then
		
			inventoryTicker:Cancel()
			
			inventoryForceTicker = C_Timer.NewTicker(1,
				function()
				
				-- print(GetInventoryItemLink("Adôkai",GetInventorySlotInfo(slotsToCheck[1])))
				
				if GetInventoryItemLink(player,GetInventorySlotInfo(slotsToCheck[1])) then
			
					for i=1, BraveReward:tablelength(slotsToCheck) do
					
						unitData[rollUnits[player]][i] = GetInventoryItemLink(player,GetInventorySlotInfo(slotsToCheck[i]))
						-- print(GetInventoryItemLink(unit,GetInventorySlotInfo(slotsToCheck[i])))
						
						-- print(unitData[rollUnits[player]][i])
						if(unitData[rollUnits[player]][i] and unitData[rollUnits[player]][i] ~= nil) then
						
							enchant = BraveReward:LoadEnchants(unitData[rollUnits[player]][i])
						
							-- If Enchant is specified and valid to use
							if(enchant ~= nil and enchant ~= false) then
							
								-- Add bonus of piece
								rolls[rollNum]["bonus"] = rolls[rollNum]["bonus"] + bonusToSlot[i]
							end
							
						end
					end
					
					-- print("inspectReady")
					
					local unitFlask = BraveReward:GetUnitAura(unit, flasks)
					if unitFlask ~= false and unitFlask ~= nil then
						rolls[rollNum]["bonus"] = rolls[rollNum]["bonus"] + bonusToAura["Flask"]
					end
					local unitFood = BraveReward:GetUnitAura(unit, food)
					if unitFood ~= false and unitFood ~= nil then
						rolls[rollNum]["bonus"] = rolls[rollNum]["bonus"] + bonusToAura["Buffood"]
					end
					-- local unitBuffood = BraveReward:GetUnitAura(unit, flasks)
				
					ClearInspectPlayer(unit)
					unitData[rollUnits[player]]["inventoryReady"] = true
					
					inventoryForceTicker:Cancel()
				end
				
			end)
		end
	
	end)
end

function BraveReward:ProcessRoll(data)

	msgData = BraveReward:split(select(1, data), " ")
	
		if(msgData[2] == "würfelt." or msgData[2] == "rolls.") then
		
			inspectionInProgress = true
		
			-- Get Player name
			local player = msgData[1]
			-- local player = "Adôkai"
			
			-- Get roll result
			local result = msgData[4]
			
			-- Get last part of roll String (XXX (1-100))
			local result_raw = msgData[5]
			
			-- Process string to split min and max values
				local result_sec = BraveReward:split(result_raw, "(")[1]
				local result_thrd = BraveReward:split(result_sec, ")")[1]
				local result_min = BraveReward:split(result_thrd, "-")[1]
				local result_max = BraveReward:split(result_thrd, "-")[2]
				
			
			rollUnits[player] = BraveReward:GetUnit(player)
			unitData[rollUnits[player]] = {}
			unitData[rollUnits[player]]["bonus"] = 0
			-- Determine data position in table
			unitData[rollUnits[player]]["length"] = BraveReward:tablelength(rolls) + 1
			
			-- Add Data to table
			rolls[unitData[rollUnits[player]]["length"]] = {["unit"] = rollUnits[player], ["player"] = player, ["result"] = result, ["result_min"] = result_min, ["result_max"] = result_max, ["bonus"] = 0}
			
			BraveReward:ProcessInventory(rollUnits[player], player, unitData[rollUnits[player]]["length"])
			
			-- print(unitData[rollUnits[player]]["inspectReady"])
			
			local outputTicker
			local tries = 0
			
			
			outputTicker = C_Timer.NewTicker(1,
				function()
			
					if unitData[rollUnits[player]]["inspectReady"] == true and unitData[rollUnits[player]]["inventoryReady"] == true then
					
						--print(rolls[length]["bonus"])
					
						if GetInventoryItemLink(player,GetInventorySlotInfo(slotsToCheck[1])) then
					
							-- Output via internal AddOn Message
							BraveReward:newMsg(rolls[unitData[rollUnits[player]]["length"]]["player"] .. " rolled " .. rolls[unitData[rollUnits[player]]["length"]]["result"] + rolls[unitData[rollUnits[player]]["length"]]["bonus"] .. " (" .. rolls[unitData[rollUnits[player]]["length"]]["result"] .. " (+" .. rolls[unitData[rollUnits[player]]["length"]]["bonus"] .. ")) (" .. rolls[unitData[rollUnits[player]]["length"]]["result_min"] .. " - " .. rolls[unitData[rollUnits[player]]["length"]]["result_max"] .. ")")
							outputTicker:Cancel()
						
						else
						
							if(tries >= 10) then
								BraveReward:newMsg("Inventory of " .. rolls[unitData[rollUnits[player]]["length"]]["player"] .. " could not be loaded!")
								outputTicker:Cancel()
							end
							
						end
						
						inspectionInProgress = false
						tries = tries + 1
					end
				end)
			
		end
end


-------------------------------------------------------------------------------------------------------------------------------
	-------------------------------------------------  EVENT HANDLER  -------------------------------------------------
-------------------------------------------------------------------------------------------------------------------------------


f:SetScript("OnEvent",function(self,event, ...)

	--if IsInRaid() then
	
		if event == "CHAT_MSG_SYSTEM" then
			
			-- Initialize query index
			unitQuery[BraveReward:tablelength(unitQuery) + 1] = ...
			
				
				local queryTicker

				-- Start ticker to query rolls
				queryTicker = C_Timer.NewTicker(4, function()
				
					if unitQuery[1] ~= nil then
						-- Process roll for current index
						BraveReward:ProcessRoll(unitQuery[1])
					end
					-- Shift the table back by 1 unit
					table.remove(unitQuery, 1)
				
				end, BraveReward:tablelength(unitQuery))
			
		end
	--end
	
	if event == "INSPECT_READY" then
		
		-- print(event)
		-- BraveReward:LoadInventory(...)
		
		local player = select(6, GetPlayerInfoByGUID(select(1, ...)))
		local unitId = BraveReward:GetUnit(player)
		
		if player ~= nil and (UnitInParty(unitId) == true or (UnitInParty(unitId) == false and unitId == "player")) then
			--print(unitId)
			if not unitData[unitId] then
				unitData[unitId] = {}
			end
			unitData[unitId]["inspectReady"] = true
			
			--print(GetInventoryItemLink(unitId,GetInventorySlotInfo(slotsToCheck[1])))
		end
		
	end
	


	-------------------------------------------------------------------------------------------------------------------------------
		-------------------------------------------------  ON LOGIN  -------------------------------------------------
	-------------------------------------------------------------------------------------------------------------------------------

	if event == "PLAYER_ENTERING_WORLD" and IsAddOnLoaded("BraveReward") then
		
		-- BraveReward:newMsg("Brave Reward locked'n loaded.")
		
	end

end)